Bug 207144 - Stop relying on ResponsivenessTimer to keep the WebProcess from suspending during initialization
Summary: Stop relying on ResponsivenessTimer to keep the WebProcess from suspending du...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit2 (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Chris Dumez
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2020-02-03 13:55 PST by Chris Dumez
Modified: 2020-02-11 16:31 PST (History)
6 users (show)

See Also:


Attachments
Patch (5.69 KB, patch)
2020-02-03 13:57 PST, Chris Dumez
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Dumez 2020-02-03 13:55:45 PST
Stop relying on ResponsivenessTimer to keep the WebProcess from suspending during initialization. Instead, make the WebProcess::InitializeWebProcess IPC async with a reply and take a process assertion on behalf of the WebContent process until we get a response back.
This avoids sending an extra PING IPC to the WebProcess for no reason (since we're already sending the WebProcess::InitializeWebProcess IPC) and this is also more reliable since the ResponsivenessTimer can actually time out and cause the process to get suspended during initialization still.
Comment 1 Chris Dumez 2020-02-03 13:57:51 PST
Created attachment 389563 [details]
Patch
Comment 2 WebKit Commit Bot 2020-02-03 21:47:02 PST
Comment on attachment 389563 [details]
Patch

Clearing flags on attachment: 389563

Committed r255662: <https://trac.webkit.org/changeset/255662>
Comment 3 WebKit Commit Bot 2020-02-03 21:47:03 PST
All reviewed patches have been landed.  Closing bug.
Comment 4 Radar WebKit Bug Importer 2020-02-03 21:48:15 PST
<rdar://problem/59139367>
Comment 5 Chris Dumez 2020-02-04 08:30:04 PST
Follow-up fix for assertions on bots:
<https://trac.webkit.org/changeset/255679>
Comment 6 Chris Dumez 2020-02-04 15:11:05 PST
(In reply to Chris Dumez from comment #5)
> Follow-up fix for assertions on bots:
> <https://trac.webkit.org/changeset/255679>

Improved follow up fix: https://trac.webkit.org/changeset/255705/webkit
Comment 7 Chris Dumez 2020-02-05 08:28:13 PST
Follow-up fix: <https://trac.webkit.org/changeset/255814>
Comment 8 Chris Dumez 2020-02-11 16:31:28 PST
Committed r256396: <https://trac.webkit.org/changeset/256396>